SELECT e.JobTitle,
	   a.City,
	   p.LastName + ', ' + p.FirstName AS EmployeeName
FROM HumanResources.Employee AS e
JOIN Person.BusinessEntityAddress AS bea
ON e.BusinessEntityID=bea.BusinessEntityID
JOIN Person.Address a
ON bea.AddressID = a.AddressID
JOIN Person.Person AS p
ON e.BusinessEntityID = p.BusinessEntityID;

-- Hash Match JOIN quizas representen la forma mas eficiente para que el Query Optimizer una(join) dos tablas
-- es posible que podamos afinar nuestra consulta para hacer disponible que el QO use tecnicas como 
-- Nested Loop o Merge Join.  Encontrar un Hash Match Join en un plan de ejecucin "algunas" veces puede 
-- indicar

--1. Ausencia de un indice o un indice inusable
--2. Ausencia de una clausula WHERE
--3. La clausula WHERE incluye un calculo o conversion que la haga Non-Sargable



-- Nested Loop 

--=========================================================================================
-- Merge Join
-- Este operador trabaja a partir de datos ordenados(si y solo si). Aunque es frecuente que
-- los datos no esten ordenados y se requiere de un operador SORT y le resta eficiencia
--=========================================================================================
SELECT c.CustomerId
FROM Sales.SalesOrderDetail od
JOIN Sales.SalesOrderHeader oh
ON od.SalesOrderID=oh.SalesOrderID
JOIN Sales.Customer c ON oh.CustomerID = c.CustomerID;