--Clustered Index Scan
SELECT ct.*
FROM Person.ContactType AS ct;


--Clustered Index Seek
SELECT ct.*
FROM Person.ContactType AS ct
WHERE ct.ContactTypeID = 7;

--Nonclustered Index Seek
SELECT ct.*
FROM Person.ContactType AS ct
WHERE Name LIKE 'Own%'

--Table Scan
CREATE TABLE Test
(
  TestCol1  INT,
  TestCol2  INT
);

INSERT INTO dbo.Test
        ( TestCol1, TestCol2 )
VALUES  ( 1, -- TestCol1 - int
          1  -- TestCol2 - int
          ),(2,2),(3,3);

SELECT * FROM dbo.Test

DROP TABLE dbo.Test;

--Key Lookup
SELECT p.BusinessEntityID,
       p.LastName,
	   p.FirstName,
	   p.NameStyle
FROM Person.Person AS p
WHERE p.LastName LIKE 'Jaf%'

--Porque? Nuestros el indice no cubre la consulta
SELECT p.BusinessEntityID,
       p.LastName,
	   p.FirstName
	   --p.NameStyle -- Comentaremos esta columna que no forma parte del indice
FROM Person.Person AS p
WHERE p.LastName LIKE 'Jaf%'

--Adaptando nuestro indice

DROP INDEX [IX_Person_LastName_FirstName_MiddleName] ON Person.Person;
GO

CREATE NONCLUSTERED INDEX [IX_Person_LastName_FirstName_MiddleName] ON [Person].[Person]
(
	[LastName] ASC,
	[FirstName] ASC,
	[MiddleName] ASC
) INCLUDE(NameStyle)

--Reejecutando la consulta
SELECT p.BusinessEntityID,
       p.LastName,
	   p.FirstName,
	   p.NameStyle 
FROM Person.Person AS p
WHERE p.LastName LIKE 'Jaf%'

