--===================================================================================
-- Desactiving AUTO CREATE STATISTICS
--===================================================================================
ALTER DATABASE PerformanceV3 SET AUTO_CREATE_STATISTICS OFF;

--===================================================================================
-- Getting the active statistics that belong to Orders table
--===================================================================================
SELECT S.Name AS stats_name,
QUOTENAME(OBJECT_SCHEMA_NAME(S.object_id)) + N'.' + QUOTENAME(OBJECT_NAME(S.object_id)) AS object,
C.Name AS column_name
FROM sys.stats AS S
 INNER JOIN sys.stats_columns AS SC
  ON S.object_id=SC.object_id
  AND S.stats_id=SC.stats_id
 INNER JOIN sys.columns AS C
  ON SC.object_id=C.object_id
  AND SC.column_id = C.column_id
WHERE S.object_id = OBJECT_ID(N'dbo.Orders')  --Put here the name of the Table
  AND S.auto_created = 1;


 --===================================================================================
-- Dropping the statistics of Orders table
--====================================================================================
DROP STATISTICS dbo.Orders._WA_Sys_00000002_3B75D760;
DROP STATISTICS dbo.Orders._WA_Sys_00000003_3B75D760;



--Evaluating how many rows there is
SELECT COUNT(1) FROM dbo.Orders

--Consulta
DECLARE @i AS INT=999900;

--Explanation in the use of the value directly

SELECT orderid,custid,empid,shipperid,orderdate,filler
FROM dbo.Orders
WHERE orderid > 999900--@i;

--30% according the Magic Table for unknown inputs


SELECT orderid,custid,empid,shipperid,orderdate,filler
FROM dbo.Orders
WHERE custid <='C0000000010';



--Reactivando las estadisticas
--limpiando la cache
ALTER DATABASE PerformanceV3 SET AUTO_CREATE_STATISTICS ON;

DBCC FREEPROCCACHE;

